addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.valid then
		player.springspinning = false
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid then
		local character = skins[consoleplayer.skin].name
		if character == "paming" then
			if (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR)) then
				player.springspinning = false
			end
			if not (P_IsObjectOnGround(player.mo)) and player.springspinning == false and ((player.mo.state == S_PLAY_SPRING) or (player.mo.state == S_PLAY_FALL) or (player.mo.state == S_PLAY_PAIN) or (player.mo.state == S_PLAY_JUMP)) and (player.cmd.buttons & BT_SPIN) then
				player.pflags = $1|PF_JUMPED
				player.pflags = $1 & ~PF_NOJUMPDAMAGE
				player.mo.state = S_PLAY_ROLL
				player.springspinning = true
				S_StartSound(player.mo, sfx_spin)
				if (player.pflags & PF_SPINNING) then
				end
				if (player.pflags & PF_THOKKED) then
					player.pflags = $1 & ~PF_THOKKED
				end
			end
		end
	end
end)