addHook("PlayerThink", function(p)
	local pmo = p.mo
	
	if not ((pmo and pmo.valid) or (pmo.skin == "sonic") or (pmo.health) or (p.exiting))
		return
	end
	
	if pmo.usetics != nil and (p.cmd.buttons & BT_USE)
		pmo.usetics = $ + 1
	else
		pmo.usetics = 0
	end
	
	local crouchheight = 30*FRACUNIT
	
	if P_IsObjectOnGround(pmo) and not (p.pflags&PF_SPINNING)
		if (pmo.usetics ~= 0)
			pmo.state = S_PLAY_GLIDE_LANDING
			p.pflags = $|PF_FULLSTASIS
			p.height = crouchheight
		else
			if (pmo.state == S_PLAY_GLIDE_LANDING) 
				p.height = 48*FRACUNIT
				if  p.pflags&PF_FULLSTASIS
					p.pflags = $ & ~PF_FULLSTASIS
				end
			end
		end
	end
end)